﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Syncfusion.XlsIO;

namespace ExcelTest
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void button1_Click(object sender, EventArgs e)
		{
			button1.Enabled = false;
			var timeStart = DateTime.Now;
			var sheets = new string[] { "Data", "Info" };
			
			ExcelEngine _excelEngine = new ExcelEngine();
			IApplication application = _excelEngine.Excel;
			IWorkbook workbook = workbook = application.Workbooks.Create(sheets);;
			
			var DataSheet = workbook.Worksheets["Data"];
			DataSheet.Range[1, 1, 1, 100].ColumnWidth = 15;

			workbook.Version = ExcelVersion.Excel2013;
			workbook.IsRightToLeft = true;

			var secondsWrapText = 0;
			
			for (int row = 1; row < 666; row++)
			{
				for (var column = 1; column <= 15; column++)
				{
					var cell = DataSheet.Range[row, column];
					cell.Text = row.ToString() + "_" + column.ToString() + " long text that is larger then cell size";
					var timeStartWrapText = DateTime.Now;
					cell.WrapText = true;
					var timeEndWrapText = DateTime.Now;
					var timeSpanWrapText = timeEndWrapText - timeStartWrapText;
					secondsWrapText += timeSpanWrapText.Seconds + (timeSpanWrapText.Minutes / 60);
				} 
			}
			var path = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "1.xlsx");

			// Saving the workbook to disk.
			workbook.SaveAs(path, ExcelSaveType.SaveAsXLS);

			// Closing the workbook.
			workbook.Close();

			// Dispose the Excel engine.
			_excelEngine.Dispose();

			var timeEnd = DateTime.Now;
			var timeSpan = timeEnd - timeStart;
			var seconds = secondsWrapText += timeSpan.Seconds + (timeSpan.Minutes / 60);
			MessageBox.Show("All Done in " + seconds + " Seconds\r\n" +
			"WrapText done in " + secondsWrapText + " Seconds");
			button1.Enabled = true;
			
		}
	}
}
